print "============================================================================"
print "                             TIMIT_CMU_run.py                               "
print "============================================================================"

#Copyright 2017 Ole Petter Thorsrud
#!/usr/bin/python
#coding=utf-8

#--------------------------bibliotek--------------------------#
import sys
import os
import subprocess
import shutil
from shutil import copy,copyfile
from subprocess import call
#------------------------------------------------------------#
# Akustiske modellparametere
numLeavesTri1=2500
numGaussTri1=15000
numLeavesMLLT=2500
numGaussMLLT=15000
numLeavesSAT=2500
numGaussSAT=15000
num_leavesVTLN=2500
num_gaussVTLN=15000

feats_nj=10
train_nj=30
decode_nj=5

#------------------------Definisjoner------------------------#
#VIKTIG at dette gjores for hver bruker som benytter skriptet
PWD=os.getcwd() #Jobber ut i fra mappen til dette skriptet
SCRIPTS=PWD+"/scripts"
timit='/home/studenter/olepth/taledatabase/timit' #Definer hvor taledatabasen timit ligger
#------------------------------------------------------------#
#####################################################################################
subprocess.call(['bash', PWD+"/path.sh"])
subprocess.call(['bash', PWD+"/cmd.sh"])
subprocess.call(['bash', PWD+"/utils/parse_options.sh"])
subprocess.call(['bash', SCRIPTS+"/restart.sh"])

#-----------------Forbereder akustisk data for TIMIT----------------#
#subprocess.call(['bash', PWD+"/local/timit_data_prep.sh", timit])
#subprocess.call(['bash', PWD+"/local/timit_prepare_dict.sh"])
#subprocess.call(['bash', PWD+"/utils/prepare_lang.sh", PWD+"/data/local/dict_timit", "sil", PWD+"/data/local/lang", PWD+"/data/lang"])
#subprocess.call(['bash', PWD+"/local/timit_format_data.sh"])
 

#-----------------Forbereder akustisk data for CMU_KIDS-----------------#
#subprocess.call(['bash', SCRIPTS+"/cmu_dict_prep.sh"])
#subprocess.call(['bash', PWD+"/utils/prepare_lang.sh", PWD+"/data/local/dict_cmu", "sil", PWD+"/data/local/lang_test_bg", PWD+"/data/lang_test_bg"])
#subprocess.call(['bash', SCRIPTS+"/lan_mod.sh"])
#subprocess.call(['python', SCRIPTS+"/cmu_data_prep_WER.py"])
#subprocess.call(['python', SCRIPTS+"/cmu_data_prep_PER.py"])


print "============================================================================"
print "       MFCC-egenskapsuttrekning og CMVN for baade trening og testsett       "
print "============================================================================"


#-----------------------MFCC-egenskaper-----------------------#
mfccdir=PWD+'/mfcc'

####TRAIN####
#subprocess.call(['bash', PWD+"/steps/make_mfcc.sh", PWD+"/data/train", PWD+"/exp/make_mfcc/train", mfccdir])
#subprocess.call(['bash', PWD+"/steps/compute_cmvn_stats.sh", PWD+"/data/train", PWD+"/exp/make_mfcc/train", mfccdir])

####TEST####
#subprocess.call(['bash', PWD+"/steps/make_mfcc.sh", PWD+"/data/test", PWD+"/exp/make_mfcc/test", mfccdir])
#subprocess.call(['bash', PWD+"/steps/compute_cmvn_stats.sh", PWD+"/data/test", PWD+"/exp/make_mfcc/test", mfccdir])

print "============================================================================"
print "                     Trening og dekoding av monofoner                       "
print "============================================================================"

print "train_mono.sh kjorer"
#subprocess.call(['bash', PWD+"/steps/train_mono.sh", PWD+"/data/train", PWD+"/data/lang", PWD+"/exp/mono"])
print "mkgraph.sh kjorer"
#subprocess.call(['bash', PWD+"/utils/mkgraph.sh", PWD+"/data/lang_test_bg", PWD+"/exp/mono", PWD+"/exp/mono/graph"])
print "decode.sh for test kjorer"
#subprocess.call(['bash', PWD+"/steps/decode.sh",PWD+"/exp/mono/graph", PWD+"/data/test", PWD+"/exp/mono/decode_test"])
print "Trening og dekoding av monofoner er ferdig"

print "============================================================================"
print "                       Trening og dekoding av deltaer                       "
print "============================================================================"

print "align_si.sh kjorer"
#subprocess.call(['bash', PWD+"/steps/align_si.sh", PWD+"/data/train", PWD+"/data/lang", PWD+"/exp/mono", PWD+"/exp/mono_ali"])
print "train_deltas.sh kjorer"
#subprocess.call(['bash', PWD+"/steps/train_deltas.sh", str(numLeavesTri1), str(numGaussTri1), PWD+"/data/train", PWD+"/data/lang", PWD+"/exp/mono_ali", PWD+"/exp/tri1"])
print "mkgraph.sh kjorer"
#subprocess.call(['bash', PWD+"/utils/mkgraph.sh", PWD+"/data/lang_test_bg", PWD+"/exp/tri1", PWD+"/exp/tri1/graph"])
print "decode.sh for test kjorer"
#subprocess.call(['bash', PWD+"/steps/decode.sh", PWD+"/exp/tri1/graph", PWD+"/data/test", PWD+"/exp/tri1/decode_test"])

print "============================================================================"
print "                      LDA og MLLT trening og dekoding                       "
print "============================================================================"

print "align_si.sh kjorer"
#subprocess.call(['bash', PWD+"/steps/align_si.sh", PWD+"/data/train", PWD+"/data/lang", PWD+"/exp/tri1", PWD+"/exp/tri1_ali"])
print "train_lda_mllt.sh kjorer"
#subprocess.call(['bash', PWD+"/steps/train_lda_mllt.sh", str(numLeavesMLLT), str(numGaussMLLT), PWD+"/data/train", PWD+"/data/lang", PWD+"/exp/tri1_ali", PWD+"/exp/tri2"])
print "mkgraph.sh kjorer"
#subprocess.call(['bash', PWD+"/utils/mkgraph.sh", PWD+"/data/lang_test_bg", PWD+"/exp/tri2", PWD+"/exp/tri2/graph"])
print "decode.sh for test kjorer"
#subprocess.call(['bash', PWD+"/steps/decode.sh", PWD+"/exp/tri2/graph", PWD+"/data/test", PWD+"/exp/tri2/decode_test"])

print "============================================================================"
print "                              VTLN og SAT                                   "
print "============================================================================"

print "align_si.sh kjorer"
#subprocess.call(['bash', PWD+"/steps/align_si.sh", PWD+"/data/train", PWD+"/data/lang", PWD+"/exp/tri2", PWD+"/exp/tri2_ali"])
print "run_vtln.sh kjorer"
#subprocess.call(['bash', PWD+"/scripts/run_vtln.sh"])

print "============================================================================"
print "                  TIMIT_CMU_run.py er ferdig og velykket                    "
print "============================================================================"
