##########################################################################################
###                                  CMU_DATA_PREP.PY                                  ###
##########################################################################################

#!/usr/bin/env python
#coding=utf-8
#Copyright 2017 Ole Petter Thorsrud

import sys
import os
import subprocess
import shutil
from shutil import copy
from subprocess import call

#--------------Mappestruktur--------------#
PWD="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu/scripts" #PWD er "cmu_data_prep_PER.py" mappe
DIGITS_AUDIO="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu/digits_audio"
DATA="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu/data"
TEST_CMU=DIGITS_AUDIO+"/test_cmu" #Dette er mappen til test-talerene. 
TEST=DATA+"/test"

#--------Deklarering av variabler--------#
## NB Dette maa gjores for hver bruker ##

#Definer hvor sph2pipe-funksjonen ligger:
SPH2PIPE="/home/studenter/olepth/kaldi-trunk/tools/sph2pipe_v2.5/sph2pipe"
#Definer onsket sph2pipe funksjon:
WAV = "-f wav" 
#Definer hvor taledatabasen ligger:
CMUKIDS="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu2/digits_audio/talebest"

newpath = DATA+"/test"
if not os.path.exists(newpath):
    os.makedirs(newpath)
    
def acoustic_data():
	
###----------------Lager text for test_clean------------------###
    
    os.chdir(PWD)
    with open("transcrp.txt","r") as istr:
        os.chdir(TEST)
        with open("text", "w") as ostr:
            for line in istr:
                if '/' not in line and '[' not in line and ']' not in line: #Fjerner alle 
											#linjer som inneholder '/','[' eller ']'
                    ostr.write(line)		#lager ny textfil med korrekt uttale
        ostr.close()
    istr.close()

###----------------Lager utt2spk for test----------------###

    os.chdir(TEST)						#Navigerer til mappen "DIGITS_AUDIO"
    with open("text", "r") as iuttstr:				#Leser "text"
        with open("utt2spk", "w") as uttstr:	#Lager en ny fil: "utt2spk"
            for line in iuttstr:					
                line = line.rstrip('\n')
                line = line[:8] + " " + line[:4]
                uttstr.write(line+"\n")				#Skriver til filen "utt2spk"
        uttstr.close()							#Lukker filen "utt2spk"
    iuttstr.close() 							#Lukker filen "text"
    
###---------------Lager wav.scp for test-----------------###
    os.chdir(TEST)
    with open("text","r") as iuttstr:	#Tar utgangspunkt i text-filen
    	with open("wav.scp","w") as uttstr:
    		for line in iuttstr:
    		    line = line.rstrip('n')
    		    line2 = line[:8]+" "+SPH2PIPE+" "+WAV+" "+CMUKIDS 
    		    line3 = line2+"/"+line[:4]+"/signal/"+line[:8]+".sph |" #Genererer wavscp
    											#ut i fra deklareringene over
    	            uttstr.write(line3+"\n")
    	uttstr.close()
    iuttstr.close()

###---------------Endrer text til fonemer for test-----------------###
def text_fonem():
    os.chdir(PWD)
    lexicon = open("lexiconcmu.txt","r")
    text = open("textcmu.txt","r")
    os.chdir(TEST)
    outfile = open("text","w")

    word = []
    lyd = []

    for line in lexicon:
        linjeliste = line.split()
    	word.append(linjeliste[0])
    	lyd.append(' '.join(linjeliste[1:]))

    for line in text:
        linjeliste = line.split()
    	for i in range(1,len(linjeliste)):
            index = word.index("%s"%linjeliste[i].lower())
            linjeliste[i] = lyd[index]
        outfile.write(' '.join(linjeliste))
        outfile.write("\n")

###--------------Lager spk2utt for test------------------###
    os.chdir(PWD)
    subprocess.call(['bash', PWD+"/spk2utt.sh"]) #Kaller paa Kaldi-skriptet spk2utt

###--------------Lager spk2gender for test---------------###
    os.chdir(TEST)
    with open("spk2utt","r") as ispkstr:  #Tar utgangspunkt i spk2utt
        with open("spk2gender","w") as uspkstr: #Lager ny fil, spk2gender
            for line in ispkstr:
                line = line.rstrip('\n')
                line = line[:4]+ " " + line[:1] #benytter de fire forste bokstavene
                                                                                #i spk2utt og legger sammen med den forste
                uspkstr.write(line+"\n")
        uspkstr.close()
    ispkstr.close()

#---------------Endrer plang_test_bg slik at den blir som lang-mappen-------------#
    os.chdir(PWD)
    subprocess.call(['bash', PWD+"/cmu_langper_prep.sh"]) #Kaller paa Kaldi-skriptet spk2utt

def main():
    acoustic_data()
    text_fonem()
    
        
if __name__=="__main__":
    main() 
