##########################################################################################
###                                  CMU_DATA_PREP_WER.py                              ###
##########################################################################################

#!/usr/bin/env python
#coding=utf-8
#Copyright 2017 Ole Petter Thorsrud

import sys
import os
import subprocess
import shutil
from shutil import copy
from subprocess import call

#--------------Mappestruktur--------------#
PWD="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu/scripts"	#PWD er "cmu_data_prep.py" mappe
DIGITS_AUDIO="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu/digits_audio"
DATA="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu/data"
TEST_CMU=DIGITS_AUDIO+"/test_cmu" #Dette er mappen til test-talerene. 
TEST=DATA+"/test"

#--------Deklarering av variabler--------#
## NB Dette maa gjores for hver bruker ##

#Definer hvor sph2pipe-funksjonen ligger:
SPH2PIPE="/home/studenter/olepth/kaldi-trunk/tools/sph2pipe_v2.5/sph2pipe"
#Definer onsket sph2pipe funksjon:
WAV = "-f wav" 
#Definer hvor taledatabasen ligger:
CMUKIDS="/home/studenter/olepth/kaldi-trunk/egs/timit_cmu2/digits_audio/talebest"
    
def acoustic_data():   
#--------------Lager data/test--------------#   
    newpath = DATA+"/test"
    if not os.path.exists(newpath):
        os.makedirs(newpath)

###----------------Lager text for test_clean------------------###  
    os.chdir(PWD)
    with open("transcrp.txt","r") as istr:
        os.chdir(TEST)
        with open("text", "w") as ostr:
            for line in istr:
                if '/' not in line and '[' not in line and ']' not in line: #Fjerner alle 
									#linjer som inneholder '/','[' eller ']'
                    ostr.write(line)		#lager ny textfil med korrekt uttale
        ostr.close()
    istr.close()	

###----------------Lager utt2spk for test----------------###

    os.chdir(TEST)						#Navigerer til mappen "DIGITS_AUDIO"
    with open("text", "r") as iuttstr:				#Leser "text"
        with open("utt2spk", "w") as uttstr:	#Lager en ny fil: "utt2spk"
            for line in iuttstr:					
                line = line.rstrip('\n')
                line = line[:8] + " " + line[:4]
                uttstr.write(line+"\n")				#Skriver til filen "utt2spk"
        uttstr.close()							#Lukker filen "utt2spk"
    iuttstr.close() 							#Lukker filen "text"
    
###---------------Lager wav.scp for test-----------------###
    os.chdir(TEST)
    with open("text","r") as iuttstr:	#Tar utgangspunkt i text-filen
    	with open("wav.scp","w") as uttstr:
    	    for line in iuttstr:
                line = line.rstrip('n')
                line2 = line[:8]+" "+SPH2PIPE+" "+WAV+" "+CMUKIDS 
                line3 = line2+"/"+line[:4]+"/signal/"+line[:8]+".sph |" #Genererer wavscp
    											#ut i fra deklareringene over
                uttstr.write(line3+"\n")
    	uttstr.close()
    iuttstr.close()

###---------------Lager wav.scp for test-----------------###
    os.chdir(PWD)
    subprocess.call(['bash', PWD+"/timit_wer_prep.sh"]) #behandler timitdaten for ordgjenkjenning

###----------------Lager wav.scp for test_cmu----------------###
### NB! Denne delen skal bare benyttes derom du bruker test_cmu og ikke test_clean! ###

#   wavpath_test=[]
#   os.chdir(DIGITS_AUDIO) 						#Navigerer til mappen "DIGITS_AUDIO"
#   outfile = open("speakers_test.txt","w") 	#Lager en liste over alle talerne 
#   											#i test-mappen
#   os.chdir(TEST_CMU)							#Navigerer til mappen "TEST_CMU"
#   folders = os.listdir(TEST_CMU)				#folder er en liste med alle talerne i test
#   for i in range(1,len(os.listdir(TEST_CMU))):
#       for fil in os.listdir(TEST_CMU+"/%s/signal"%folders[i]): #Lager en for-lokke som 
        #														lister alle talerne	#->
#           if not fil.startswith('.'):
#               outfile.write("%s\n"%fil[0:8])					 #Skriver til hver taler 
#               												 #til "speakers_test.txt"
#               wavpath_test.append(os.path.abspath(TEST_CMU+"/%s/signal/"%folders[i]+fil)) 
#               					#Finner lokasjonen til lydfilen og lagrer den i et array
#   outfile.close()								#Lukker filen
    
#   os.chdir(DIGITS_AUDIO)						#Navigerer til mappen "DIGITS_AUDIO"
#   with open("speakers_test.txt", "r") as istr:#Leser filen "speakers_test.txt"
#   	os.chdir(TEST)							#Navigerer til TEST
#       with open("wav.scp", "w") as ostr:		#Lager en ny fil wav.scp som tar 
#       										#utgangspunkt i "speakers_test.txt"
#           n=-1								#Lager en indexverdi til wavpath_test[n]
#           for line in istr:
#               if line:						#Indexverdi
#               	n=n+1						
#               line = line.rstrip('\n') + SPH2PIPE			#String: Fjerner eventuelle 
#               											#linjeskift og legger til 
#               											#lokasjonen til sp2pipe-verktoyet
#               wav = wavpath_test[n]			
#               linje = " |\n"					#String: Avslutter hver linje i dokumentet
#               								#med "linje"
#               ostr.write(line+wav+linje)		#Skriver til filen wav.scp
#       ostr.close()							#Lukker filen wav.scp
#   istr.close()								#Lukker filen speakers_test.txt

def acoustic_data2():
###--------------Lager spk2utt for test------------------###
    os.chdir(PWD)
    subprocess.call(['bash', PWD+"/spk2utt.sh"]) #Kaller paa Kaldi-skriptet spk2utt
	
###--------------Lager spk2gender for test---------------###
    os.chdir(TEST)
    with open("spk2utt","r") as ispkstr:  #Tar utgangspunkt i spk2utt
    	with open("spk2gender","w") as uspkstr: #Lager ny fil, spk2gender
            for line in ispkstr:
                line = line.rstrip('\n')
                line = line[:4]+ " " + line[:1] #benytter de fire forste bokstavene 
    						#i spk2utt og legger sammen med den forste
                uspkstr.write(line+"\n")
    	uspkstr.close()
    ispkstr.close()
def main():
    acoustic_data()
    acoustic_data2()
    
    
        
if __name__=="__main__":
    main() 
